<?php

namespace RxConnexionBundle\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;
use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Entity\ChartTypeEntity;

use RxConnexionBundle\Form\ChartTypeForm;


/**
 * @Route("/main/encounter_type")
 */
class ChartTypeController extends Controller
{
    /**
     * @Route("", name="chart_type")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Chart Type'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/ChartType/index.html.twig', array(
            'title' => 'Manage Encounter Type',
            'page_title' => 'Manage Encounter Type',
            'javascripts' => array('rxconnexion/admin/js/chartType/chartType.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="chart_type_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Chart Type Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:ChartTypeEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('chart_type_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['account_desc'],
                    $row['chart_type_group_desc'],
                    $row['code'],
                    $row['description'],
                    $row['startDate'],
                    $row['endDate'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "chart_type_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Chart Type New', 'Admin Chart Type Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $chartType = $em->getRepository('RxConnexionBundle:ChartTypeEntity')->find(base64_decode($id));
        if(!$chartType) {
            $chartType = new ChartTypeEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(ChartTypeForm::class, $chartType, $formOptions);

        if($request->getMethod() === 'POST') {

            $chartType_form = $request->get($form->getName());
            $result = $this->processForm($chartType_form, $chartType, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('chart_type'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('chart_type_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('chart_type_form'), 302);
                }
            } else {
                $form->submit($chartType_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Encounter Type';

        return $this->render('@RxConnexion/ChartType/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/chartType/chartType_form.js?v=1.0.0'),
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($chartType_form, $chartType, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:ChartTypeEntity')->validate($chartType_form);

        if(!count($errors)) {

            switch($chartType_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($chartType);
                        $em->flush();

                        $newAT = new AuditTrailEntity(
                            'Encounter Type',
                            $em->getClassMetadata(ChartTypeEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $chartType;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Encounter Type',
                        $em->getClassMetadata(ChartTypeEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $chartType;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Encounter Type',
                        $em->getClassMetadata(ChartTypeEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $chartType;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($chartType);
                        $chartType->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route("/autocomplete", name="chart_type_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');

        $result = array(
            'query' => 'chartType',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:ChartTypeEntity')->autocomplete_suggestions($q)
        );

        return new JsonResponse($result);
    }

    /**
     * @Route("/method_list_by_id", name="chart_type_method_list_by_id")
     */
    public function method_list_by_idAction(Request $request) {

        $id = $request->get('id');

        $result = array(
            'methods' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:ChartTypeEntity')->method_list_by_id($id)
        );

        return new JsonResponse($result);
    }
}
